unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Quickrpt, qrprntr, Db, DBTables;

resourcestring
  STR_DLL = 'QRDLL.DLL';
  STR_LOAD_ERROR = 'Unable to load %s';

type
  TRunReport = function (H: HWND; ReportNumber: integer; PrintIt: boolean): word; stdcall;
  EDLLLoadError = class(Exception);

  TfrmMain = class(TForm)
    btnLoad: TButton;
    btnRun: TButton;
    btnFree: TButton;
    btnPrepare: TButton;
    btnLoadRunFree: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    procedure btnLoadClick(Sender: TObject);
    procedure btnFreeClick(Sender: TObject);
    procedure btnRunClick(Sender: TObject);
    procedure btnPrepareClick(Sender: TObject);
    procedure btnLoadRunFreeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  LibHandle: THandle;
  RunReport: TRunReport;

implementation

{$R *.DFM}

procedure TfrmMain.btnLoadClick(Sender: TObject);
begin
  // Set the buttons
  btnRun.Enabled := False;
  btnPrepare.Enabled := False;
  btnFree.Enabled := False;
  btnLoadRunFree.Enabled := False;
  // Load the dll
  LibHandle := LoadLibrary(PChar(STR_DLL));
  try
    if LibHandle = 0 then
      raise EDLLLoadError.CreateFmt(STR_LOAD_ERROR,[STR_DLL]);
    @RunReport := GetProcAddress(LibHandle, 'RunReport');
    btnLoad.Enabled := False;
    btnRun.Enabled := True;
    btnFree.Enabled := True;
    btnPrepare.Enabled := True;
  finally
  end;
end;

procedure TfrmMain.btnFreeClick(Sender: TObject);
begin
  try
    FreeLibrary(LibHandle);
    btnRun.Enabled := false;
    btnFree.Enabled := false;
    btnPrepare.Enabled := False;
    btnLoad.Enabled := true;
    btnLoadRunFree.Enabled := true;
  finally
  end;
end;

procedure TfrmMain.btnRunClick(Sender: TObject);
begin
  btnFree.Enabled := false;
  RunReport(Application.Handle, 1, False);
  Application.ProcessMessages;
  btnFree.Enabled := true;
end;

procedure TfrmMain.btnPrepareClick(Sender: TObject);
begin
  btnFree.Enabled := false;
  btnPrepare.Enabled := False;
  RunReport(Application.Handle, 2, False);
  btnPrepare.Enabled := true;
  btnFree.Enabled := true;
end;

procedure TfrmMain.btnLoadRunFreeClick(Sender: TObject);
var
  LibHandle: THandle;
  RunReport: TRunReport;
begin
  LibHandle := LoadLibrary(PChar(STR_DLL));
  btnLoadRunFree.Enabled := false;
  btnLoad.Enabled := false;
  try
    if LibHandle = 0 then
      raise EDLLLoadError.CreateFmt(STR_LOAD_ERROR,[STR_DLL]);
    @RunReport := GetProcAddress(LibHandle, 'RunReport');
    RunReport(Application.Handle, 1, False);
  finally
    Application.ProcessMessages;
    FreeLibrary(LibHandle);
    btnLoadRunFree.Enabled := true;
    btnLoad.Enabled := true;
  end;
end;

end.
