library qrdll;
{$DEFINE TEST3DLL}


uses
  Sharemem,
  SysUtils,
  Classes,
  forms,
  windows,
  qrdll1 in 'qrdll1.pas' {DlltestQR: TQuickRep},
  dllint in 'dllint.pas';

function RunReport(AppHandle: HWND; ReportNumber: integer; PrintIt: boolean): word; stdcall;
var
  DlltestQR : TDlltestQR;
begin
  result := 0;

  // Set the DLL's Application handle to the caller.  If the caller didn't
  // pass in handle, we grab the handle of the ActiveWindow
  If AppHandle = 0 Then
    AppHandle := GetActiveWindow;

  Application.handle := AppHandle;

  // We create a new instance of the report to allow multiple
  // entries into the DLL at the same time.
  try
    DlltestQR := TDlltestQR.Create(nil);
    case ReportNumber of
      1:
      begin
        with DlltestQR do
        begin
          if PrintIt then
            Print
          else
            Preview;
        end;
      end;
      2: begin
        with DlltestQR do
        begin
          Prepare;
          qrprinter.free;
          qrprinter := nil;
        end;
      end;
    end;
    DlltestQR.free;
  except
    On E: Exception Do
      Application.HandleException( E );
  end;
  // Clear out the DLL's Application handle
  Application.handle := 0;
end;

exports
  RunReport;
end.
